Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# Xabsl2BooleanExpression Class Reference

Base class for all boolean expressions inside an option graph. More...

`#include <Xabsl2BooleanExpression.h>`

Inheritance diagram for Xabsl2BooleanExpression:

[legend]
List of all members.

## Public Member Functions
virtual bool | getValue ()=0
| Evaluates the boolean expression.
virtual | ~Xabsl2BooleanExpression ()=0
| Destructor.
## Static Public Member Functions
Xabsl2BooleanExpression * | create (Xabsl2InputSource &input, Xabsl2Option *subsequentOption, Xabsl2ErrorHandler &errorHandler, Xabsl2Array< double > &parameters, Xabsl2Symbols &symbols, unsigned long &timeOfOptionExecution, unsigned long &timeOfStateExecution)
| Creates a boolean expression depending on the input.
## Static Private Member Functions
bool | createOperand (Xabsl2BooleanExpression *&operand, Xabsl2InputSource &input, Xabsl2Option *subsequentOption, Xabsl2ErrorHandler &errorHandler, Xabsl2Array< double > &parameters, Xabsl2Symbols &symbols, unsigned long &timeOfOptionExecution, unsigned long &timeOfStateExecution)
| Creates a boolean expression depending on the input.

## Detailed Description

Base class for all boolean expressions inside an option graph.

Author:
  Martin Lötzsch

Definition at line 24 of file Xabsl2BooleanExpression.h.

## Constructor & Destructor Documentation

Xabsl2BooleanExpression::~Xabsl2BooleanExpression | ( |  | ) | `[pure virtual]`

| Destructor. Definition at line 12 of file Xabsl2BooleanExpression.cpp.

## Member Function Documentation

virtual bool Xabsl2BooleanExpression::getValue | ( |  | ) | `[pure virtual]`

| Evaluates the boolean expression. Implemented in Xabsl2AndOperator, Xabsl2OrOperator, Xabsl2NotOperator, Xabsl2BooleanInputSymbolRef, Xabsl2subsequentOptionReachedTargetStateCondition, Xabsl2EnumeratedInputSymbolComparison, Xabsl2RelationalAndEqualityOperator, Xabsl2EqualToOperator, Xabsl2NotEqualToOperator, Xabsl2LessThanOperator, Xabsl2LessThanOrEqualToOperator, Xabsl2GreaterThanOperator, and Xabsl2GreaterThanOrEqualToOperator. Referenced by Xabsl2IfElseBlock::getNextState(), Xabsl2ConditionalExpression::getValue(), and Xabsl2NotOperator::getValue().

Xabsl2BooleanExpression * Xabsl2BooleanExpression::create | ( | Xabsl2InputSource & | input,
|  | Xabsl2Option * | subsequentOption,
|  | Xabsl2ErrorHandler & | errorHandler,
|  | Xabsl2Array< double > & | parameters,
|  | Xabsl2Symbols & | symbols,
|  | unsigned long & | timeOfOptionExecution,
|  | unsigned long & | timeOfStateExecution
| ) | `[static]`

  | Creates a boolean expression depending on the input. Parameters:
  input | An input source for the intermediate code. It must be opened and read until A position where a boolean expression starts.
  subsequentOption | The subsequent option of the state. 0 if the subsequent behavior is a basic behavior
  errorHandler | A reference to a Xabsl2ErrorHandler instance
  parameters | The parameters of the option
  symbols | All available symbols
  timeOfOptionExecution | The time how long the option is already active
  timeOfStateExecution | The time how long the state is already active
Definition at line 16 of file Xabsl2BooleanExpression.cpp. References Xabsl2OrOperator::addOperand(), Xabsl2AndOperator::addOperand(), Xabsl2RelationalAndEqualityOperator::create(), Xabsl2DecimalExpression::createOperand(), createOperand(), Xabsl2ErrorHandler::error(), Xabsl2ErrorHandler::message(), Xabsl2InputSource::readString(), Xabsl2InputSource::readValue(), and XABSL2_DEBUG_INIT. Referenced by createOperand(), Xabsl2ConditionalExpression::Xabsl2ConditionalExpression(), and Xabsl2IfElseBlock::Xabsl2IfElseBlock().

Here is the call graph for this function:

bool Xabsl2BooleanExpression::createOperand | ( | Xabsl2BooleanExpression *& | operand,
|  | Xabsl2InputSource & | input,
|  | Xabsl2Option * | subsequentOption,
|  | Xabsl2ErrorHandler & | errorHandler,
|  | Xabsl2Array< double > & | parameters,
|  | Xabsl2Symbols & | symbols,
|  | unsigned long & | timeOfOptionExecution,
|  | unsigned long & | timeOfStateExecution
| ) | `[static, private]`

  | Creates a boolean expression depending on the input. Used by the create() function to create boolean operands. Parameters:
  operand | The expression to be created
  input | An input source for the intermediate code. It must be opened and read until A position where a boolean operand starts.
  subsequentOption | The subsequent option of the state. 0 if the subsequent behavior is a basic behavior
  errorHandler | A reference to a Xabsl2ErrorHandler instance
  parameters | The parameters of the option
  symbols | All available symbols
  timeOfOptionExecution | The time how long the option is already active
  timeOfStateExecution | The time how long the state is already active
Returns: If the creation was successful Definition at line 165 of file Xabsl2BooleanExpression.cpp. References create(), Xabsl2ErrorHandler::error(), and Xabsl2ErrorHandler::errorsOccurred. Referenced by create().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- Tools/Xabsl2/Xabsl2Engine/Xabsl2BooleanExpression.h
- Tools/Xabsl2/Xabsl2Engine/Xabsl2BooleanExpression.cpp